//! 系统内核驱动

pub mod clocksource;
pub mod console;
pub mod irqchip;
#[cfg(aarch64_moana)]
pub mod psci;

pub(crate) fn writel_relaxed(base: usize, val: u32) {
    let reg = base as *mut u32;
    unsafe {
        reg.write_volatile(val);
    }
}

pub(crate) fn readl_relaxed(base: usize) -> u32 {
    let reg = base as *const u32;
    unsafe { reg.read_volatile() }
}
